; render hand edge shader
; v0 - 3d position
; v1 - vertex colors
; v3 - 3d normal
; v4 - texture coordinates

#define CLIP_MATRIX		0
#define CLIP_MATRIX_1	1
#define CLIP_MATRIX_2	2
#define CLIP_MATRIX_3	3

#define INVERSE_WORLD_MATRIX		4
#define INVERSE_WORLD_MATRIX_1	5
#define INVERSE_WORLD_MATRIX_2	6

#define TRANS_MATRIX		7
#define TRANS_MATRIX_1	8
#define TRANS_MATRIX_2	9
#define TRANS_MATRIX_3	10

#define LIGHT_POSITION_A	11
#define LIGHT_POSITION_B	12

#define EYE_POSITION	13

#define TEXTURE_OFFSET		14
#define TEXTURE_OFFSET_1	15
#define TEXTURE_OFFSET_2	16
#define TEXTURE_OFFSET_3	17

#define TEXTURE_OFFSET_B	18
#define TEXTURE_OFFSET_B_1	19
#define TEXTURE_OFFSET_B_2	20
#define TEXTURE_OFFSET_B_3	21

vs.1.1
dcl_position v0
dcl_color0 v1
dcl_normal v3
dcl_texcoord0 v4
def c30, 0.0f, 0.9f, 0.1f, 2000.0f ; depth modifiers--y and z used to clamp values to 0.1-1.0, w is far plane
def c31, 0.0f, 0.0f, 2.0f, -1.0f ; bias
def c32, 0.0f, 1.0f, 0.0f, 1.0f ; up vector
def c33, 0.0f, 0.0f, 0.0f, 0.7f ; threshold
def c34, 0.0f, -1.0f, 0.0f, 1.0f ; reverse up
def c35, 0.0f, 0.0f, 0.0f, 0.5f ; bias


dp4 r0.x, v0, c[TRANS_MATRIX]      ;emit projected position
dp4 r0.y, v0, c[TRANS_MATRIX_1]    ;emit projected position
dp4 r0.z, v0, c[TRANS_MATRIX_2]    ;emit projected position
dp4 r0.w, v0, c[TRANS_MATRIX_3]    ;emit projected position

mov oPos, r0

; grab eye to vertex vector
add r2, v0, -c[EYE_POSITION]
dp3 r2.w, r2, r2
rsq r2.w, r2.w

; stick offset distance from camera in oD0 alpha
mul r3.w, r2.w, c30.w
rcp r3.w, r3.w
mad oD0, r3.w, c30.x, c30.y

; calculate new coordinate system into r4-r6
mul r6, r2, r2.w		; z-axis

; x-axis = up x z-axis( 3-vector cross-product)
mul r4, c32.yzxw, r6.zxyw
mad r4, -r6.yzxw, c32.zxyw, r4

; normalize x-axis
dp3 r4.w, r4, r4
rsq r4.w, r4.w
mul r4, r4, r4.w

; y-axis = z-axis x x-axis
mul r5, r6.yzxw, r4.zxyw
mad r5, -r4.yzxw, r6.zxyw, r5

; change vertex color to normal
mad r7, v1, c31.z, c31.w

; transpose and multiply
; transpose is necessary because we are going from new coord into old
mul r0, r4, r7.x
mad r0, r5, r7.y, r0
mad r0, r6, r7.z, r0

mov oT0, r0

mov oT1, v4 ; copy in texture coordinates for alpha
