; render normal shader
; v0 - 3d position
; v1 - vertex colors ;unused
; v3 - 3d normal
; v4 - texture coordinates

#define CLIP_MATRIX		0
#define CLIP_MATRIX_1	1
#define CLIP_MATRIX_2	2
#define CLIP_MATRIX_3	3

#define INVERSE_WORLD_MATRIX		4
#define INVERSE_WORLD_MATRIX_1	5
#define INVERSE_WORLD_MATRIX_2	6

#define TRANS_MATRIX		7
#define TRANS_MATRIX_1	8
#define TRANS_MATRIX_2	9
#define TRANS_MATRIX_3	10

#define LIGHT_POSITION_A	11
#define LIGHT_POSITION_B	12

#define EYE_POSITION	13

#define TEXTURE_OFFSET		14
#define TEXTURE_OFFSET_1	15
#define TEXTURE_OFFSET_2	16
#define TEXTURE_OFFSET_3	17

#define TEXTURE_OFFSET_B	18
#define TEXTURE_OFFSET_B_1	19
#define TEXTURE_OFFSET_B_2	20
#define TEXTURE_OFFSET_B_3	21

vs.1.1
dcl_position v0
dcl_normal v3
dcl_texcoord0 v4
def c30, 0.0f, 0.9f, 0.1f, 2000.0f ; depth modifiers--y and z used to clamp values to 0.1-1.0, w is far plane

dp4 r0.x, v0, c[TRANS_MATRIX]		;emit projected position
dp4 r0.y, v0, c[TRANS_MATRIX_1] ;emit projected position
dp4 r0.z, v0, c[TRANS_MATRIX_2] ;emit projected position
dp4 r0.w, v0, c[TRANS_MATRIX_3] ;emit projected position

mov oPos, r0

; transform normal
dp3 r1.x, v3, c[INVERSE_WORLD_MATRIX]
dp3 r1.y, v3, c[INVERSE_WORLD_MATRIX_1]
dp3 r1.z, v3, c[INVERSE_WORLD_MATRIX_2]

; renormalize it
dp3 r1.w, r1, r1
rsq r1.w, r1.w
mul r1, r1, r1.w

; grab eye vector
add r2, v0, -c[EYE_POSITION]
dp3 r2.w, r2, r2
rsq r2.w, r2.w

; stick offset distance from camera in oD0.w
mul r3.w, r2.w, c30.w
rcp r3.w, r3.w
mad oD0, r3.w, c30.x, c30.y

mov oT0, r1
mov oT1, v4 ; copy in texture coordinates for alpha
mov oT2, v4 ; copy in texture coordinates for fake_normal pixel shader
