; toon lighting shader
; v0 - 3d position
; v3 - 3d normal
; v4 - Texture coordinates

#define CLIP_MATRIX	               0
#define CLIP_MATRIX_1              1
#define CLIP_MATRIX_2              2
#define CLIP_MATRIX_3              3

#define INVERSE_WORLD_MATRIX       4
#define INVERSE_WORLD_MATRIX_1     5
#define INVERSE_WORLD_MATRIX_2     6

#define TRANS_MATRIX               7
#define TRANS_MATRIX_1             8
#define TRANS_MATRIX_2             9
#define TRANS_MATRIX_3             10

#define LIGHT_POSITION_A           11
#define LIGHT_POSITION_B           12

#define EYE_POSITION               13

#define TEXTURE_OFFSET             14
#define TEXTURE_OFFSET_1           15
#define TEXTURE_OFFSET_2           16
#define TEXTURE_OFFSET_3           17

#define TEXTURE_OFFSET_B           18
#define TEXTURE_OFFSET_B_1         19
#define TEXTURE_OFFSET_B_2         20
#define TEXTURE_OFFSET_B_3         21

vs.1.1
dcl_position v0
dcl_normal v3
dcl_texcoord0 v4
def c30, 0.0f, 0.0f, 0.0f, 0.5f
def c31, 0.0f, 0.0f, 0.0f, 0.499f
def c32, 1.0f, 0.0f, 1.0f, 0.0f

dp4 r0.x, v0, c[TRANS_MATRIX]      ;emit projected position
dp4 r0.y, v0, c[TRANS_MATRIX_1]    ;emit projected position
dp4 r0.z, v0, c[TRANS_MATRIX_2]    ;emit projected position
dp4 r0.w, v0, c[TRANS_MATRIX_3]    ;emit projected position

mov oPos, r0

; transform normal
dp3 r1.x, v3, c[INVERSE_WORLD_MATRIX]
dp3 r1.y, v3, c[INVERSE_WORLD_MATRIX_1]
dp3 r1.z, v3, c[INVERSE_WORLD_MATRIX_2]

; renormalize it
dp3 r1.w, r1, r1
rsq r1.w, r1.w
mul r1, r1, r1.w

; stick normal vector in first stage
mov oT0, r1
;mad oT0, r1, c30.a, c30.a

; stick first light position in second stage
mov oT1, c[LIGHT_POSITION_A]

; stick second light position in third stage
mov oT2, c[LIGHT_POSITION_B]

; move mesh texture data into fourth texture stage
mov oT3, v4